:- module(cmdopts, [process_options/0, cmd_options/2, set_option/2, unset_option/1]).

%% This module contains the command line options database.

:- use_module(library(dynamic), [assert/1, retract/1]).

:- dynamic cmd_options/2.

%% Valid options.

is_option(Opt) :-
	option(Opt, _, _),
	!.

option('-v',    0, "Verbose compiling").
option('-np',   0, "Exclude prelude from compilation").
option('File',  0, "File to compile").
option('-link', 0, "Test param").

set_option(Option, Value) :-
	is_option(Option),
	assert(cmd_options(Option, Value)).

unset_option(Option) :-
	is_option(Option),
	retract(cmd_options(Option, _)).

process_options :-
	current_prolog_flag(argv, Args),
	process_args(Args).

%% Throws and invalid_argument exception.
process_args([]).
process_args([File]) :-
	set_option('File', File).
process_args([A1|AL]) :-
	(
	    option(A1, _NumParams, _) ->
	    %get_params(AL, NumParams, Params),
	    set_option(A1, none),
	    process_args(AL)
	;
	    throw(invalid_arg(A1))
	).

% Incomplete support for parameters.
% get_params(_AL, 0, none).
% get_params(AL, N, LL) :-
% 	takeN(AL, N, LL),
% 	throwN(AL, ).

% throwN(

% takeN(_, 0, []).
% takeN([L|AL], N, [L|LL]) :-
% 	N1 is N - 1,
% 	takeN(AL, N1, LL).
	
	

%% Local Variables: 
%% mode: CIAO
%% update-version-comments: "off"
%% End:

