:- module(scope, [open_scope/1, close_scope/0, lookup_symbol/2, show_scope/0,
	          lookup_symbol_unref/2, insert_symbol/2, clean_scope/0]).

:- use_module(library(dynamic),  [asserta/1, retract/1, retractall/1]).
:- use_module(library(dict),     [dic_lookup/3, dic_get/3] ).

%% 
:- data scope/2.

%% 

clean_scope :-
	retractall(scope(_,_)).

open_scope(Name) :-
	asserta(scope(Name, _Dict)),
	!.

%% 
close_scope :-
%	show_scope,
	scope(Name, _Dict),
%	write(closing_scope(Name)),
%	write('\n'),
	!,
	retract(scope(Name, _)).

%% !!!! Beware all the cuts are red.
	
lookup_symbol(Name, Object) :-
	scope(_, Dicc),
	dic_get(Dicc, Name, Object).

lookup_symbol_unref(Name, Object) :-
	scope(_, Dicc),
	dic_get(Dicc, Name, Object),
	!.

lookup_symbol_unref(Name, unref(Name)) :-
	retract(scope(MName, Dicc)),
	!,
	dic_lookup(Dicc, Name, unref(Name)),
	asserta(scope(MName, Dicc)).
	
%%

insert_symbol(Name, Object) :-
	scope(SName, Dicc),
	!,
	dic_lookup(Dicc, Name, Object),
	retract(scope(SName, _)),
	asserta(scope(SName, Dicc)).
%%
show_scope :-
	scope(N, D),
	display(scope(N, D)),
	display('\n'),
	fail.

show_scope.

%% Local Variables: 
%% mode: CIAO
%% update-version-comments: "off"
%% End:

