:- module(types, [check_type/1, free_type/2, type_arity/2]).

% Operators used in types.

% TODO: Should export these ops to people who import this module.
% TODO: Revisar prioridad.
% :- op(600, xfy, ->).
% :- op(700, xfy, =>).

:- include(type_ops).

% Predicates to handle types.

% Check if Term is a valid type.

% An atom is a type name.
check_type(X) :-
	atom(X).

check_type(X) :-
	nonvar(X),
	X =.. [T, typevar(TV)],
	atom(T),
	atom(TV).

check_type(A->B) :-
	check_type(A),
	check_type(B).

check_type((_TClass=>T)) :-
	check_type(T).

% Only necessary if we have free vars in types.
type_arity(X, 0) :-
	var(X),
	!.

type_arity(_A -> B, N) :-
	!,
	type_arity(B, N1),
	N is N1 + 1.
	
type_arity(_, 0) :-
	!.

% Changes typevars to free vars.
% TODO
free_type(T, T).	


%% Local Variables: 
%% mode: CIAO
%% update-version-comments: "off"
%% End:
